#Input: n= number of verices, G= list of edges (minimum value of vertex first) ,d= dimension (2 or 3), fixed= list of fixed vertices
#Output: A= matrix that can be used to find mBézout bound computing the permanent
with(LinearAlgebra):

graph2perMatrix := proc(n, G,d,fixed) 
local E, A,i,j,k,j1,L,fixed_e ;
  E:=d*n-d^2;
  A:= Matrix(E,E);
  L := [seq(`if`(i in fixed, NULL, i), i = 1 .. n)];
  j1:=0:
  if d=2 then fixed_e:=[fixed]: elif d=3 then fixed_e:=[[fixed[1],fixed[2]],[fixed[2],fixed[3]],[fixed[1],fixed[3]]]:fi:
  for j from 1 to nops(G) do if not G[j] in fixed_e then j1:=j1+1:for i from 1 to n-d do if L[i] in G[j] then for k from 1 to d do A[j1,d*(i-1)+k]:=1:od:fi:od:fi:od:

  RETURN(A);
end proc:


#Input: G edges of Laman graph, n number of vertices
#Output: mBezout bound for all choices of K_2
graph2allBezout_2d := proc(n, G) 
local B, i, G_temp, L, j, fix_temp, A_temp ;
  with(LinearAlgebra);
  B:=[]:

  for i from 1 to nops(G) do fix_temp:=G[i]: A_temp:=graph2perMatrix(n, G,2,fix_temp):B:=[op(B),Permanent(A_temp)]: od:
  
  RETURN(B);
end proc:


#Input: G edges of Geiringer graph, n number of vertices
#Output: mBezout bound for all choices of K_3
graph2allBezout_3d := proc(n, G) 
local B, i, G_temp, L, j, fix_temp, A_temp, T,k  ;

  with(LinearAlgebra);
  B:=[]:

  T:=graphTriangles(G):
  
  for i from 1 to nops(T) do A_temp:=graph2perMatrix(n, G,3,T[i]): B:=[op(B),Permanent(A_temp)/(3^(n-3))]: od:
  
  RETURN(B);
end proc:

#Finds all triangles of a given set of edges
graphTriangles := proc(E)
local  n, i, i1, i2, i3, T, E1 ;
  T:=[];
  n:=max([seq(max(E[i]),i=1..nops(E))]);
  E1:=[seq(sort(E[i]),i=1..nops(E))];
  
  for i1 from 1 to n-2 do for i2 from i1+1 to n-1 do if [i1,i2] in E1 then for i3 from i2+1 to n do if [i1,i3] in E1 and [i2,i3] in E1 then T:=[op(T),[i1,i2,i3]]: fi: od: fi: od: od:
  

  RETURN(T);
end proc:



